SystemOrganization addCategory: #'uca-ejercicio1'!

Object subclass: #Micro
	instanceVariableNames: 'parados sentados volumen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!Micro methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:18'!
SubioPasajeroParado
 parados := parados-1.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:18'!
SubioPasajeroSentado
 sentados := sentados-1.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/2/2012 18:30'!
initialize
  sentados :=20.
  parados := 10.
  volumen := 121.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:31'!
lugaresDisponiblesParados
 ^parados! !

!Micro methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:30'!
lugaresDisponiblesSentados
 ^sentados! !

!Micro methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:31'!
lugaresDisponiblesTotales
 ^(sentados+parados)! !

!Micro methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:49'!
obtenerVolumen
 ^volumen! !

Object subclass: #Persona
	instanceVariableNames: 'lugaresx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!Persona methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:33'!
initialize 
   lugaresx :=3.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:43'!
obtenerLugaresx
^lugaresx.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:28'!
subeSiHayLugaresSentados:sentados
 ^true! !

!Persona methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:43'!
subeSiHayXLugaresLibres:lugares
 ^true! !

!Persona methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:01'!
subeSiVolumenMayora120:vol
 ^true! !

!Persona methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:44'!
subeSiempre
 ^false! !

Persona subclass: #PersonaApurada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!PersonaApurada methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:45'!
subeSiempre
 ^true! !

Persona subclass: #PersonaClaustrofobica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!PersonaClaustrofobica methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/2/2012 18:28'!
subeSiVolumenMayora120:vol
 ^(vol>120)! !

Persona subclass: #PersonaFiaca
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!PersonaFiaca methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:27'!
subeSiHayLugaresSentados:sentados
 ^(sentados>0)! !

Persona subclass: #PersonaModerado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!PersonaModerado methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:56'!
subeSiHayXLugaresLibres:lugares
 ^(lugares>=lugaresx)! !

Persona subclass: #PersonaObsecuente
	instanceVariableNames: 'jefe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!PersonaObsecuente class methodsFor: 'instance creation' stamp: 'gc 9/25/2012 21:11'!
conJefe: unaPersona

	^self new inicializarConJefe: unaPersona.! !

!PersonaObsecuente methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 21:12'!
inicializarConJefe: unaPersona

	jefe := unaPersona! !

TestCase subclass: #Microstest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'uca-ejercicio1'!

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:34'!
test01HayLugaresEnElMicroDisponibles
	| unMicro |
	unMicro := Micro new.
	self assert: unMicro lugaresDisponiblesTotales > 0! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:36'!
test02HayLugaresEnElMicroParados
	| unMicro |
	unMicro := Micro new.
	self assert: unMicro lugaresDisponiblesParados > 0! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 19:37'!
test03HayLugaresEnElMicroSentados
	| unMicro |
	unMicro := Micro new.
	self assert: unMicro lugaresDisponiblesSentados > 0! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:56'!
test04DadaUnaPersonaApuradaSubeSiHayLugar
	| unMicro unaPersonaApurada |
	unMicro := Micro new.
	unaPersonaApurada := PersonaApurada new.
	self assert: (unMicro lugaresDisponiblesTotales > 0).
	self assert: (unaPersonaApurada subeSiempre).
	! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:56'!
test05DadaUnaPersonaClaustrofobicaSubeSiVolumenMayor120
	| unMicro unaPersonaClaustrofobica unVolumen|
	unMicro := Micro new.
	unaPersonaClaustrofobica := PersonaClaustrofobica new.
	self assert: (unMicro lugaresDisponiblesTotales > 0).
	self assert: (unMicro obtenerVolumen >120).
	unVolumen := unMicro obtenerVolumen.
	self assert: (unaPersonaClaustrofobica subeSiVolumenMayora120:unVolumen ).! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:22'!
test06DadaUnaPersonaFiacaSubeSiHayAsientosSentados
	| unMicro unaPersonaFiaca unAsiento|
	unMicro := Micro new.
	unaPersonaFiaca := PersonaFiaca new.
	self assert: (unMicro lugaresDisponiblesTotales > 0).
    	self assert: (unMicro lugaresDisponiblesSentados  >0).
	unAsiento := unMicro lugaresDisponiblesSentados.
	self assert: (unaPersonaFiaca subeSiHayLugaresSentados:unAsiento ).
! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 20:55'!
test07DadaUnaPersonaModeradaSubeSiHayXLugaresLibres
	| unMicro unaPersonaModerado unLugar|
	unMicro := Micro new.
	unaPersonaModerado := PersonaModerado new.
	self assert: (unMicro lugaresDisponiblesTotales > 0).
    	self assert: (unMicro lugaresDisponiblesSentados  >0).
      self assert: (unMicro lugaresDisponiblesParados  >0).
      unLugar :=unMicro lugaresDisponiblesSentados + unMicro lugaresDisponiblesParados.
     self assert: (unaPersonaModerado subeSiHayXLugaresLibres:unLugar ).! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gc 9/25/2012 21:18'!
test08DadaUnaPersonaObsecuenteSubeSiSuJefeSube
	| unMicro unaPersonaObsecuente unJefe |
	unMicro := Micro new.
	unJefe := PersonaApurada new.
	unaPersonaObsecuente := PersonaObsecuente conJefe: unJefe.
	self assert: unMicro lugaresDisponiblesTotales > 0.
	self assert: unMicro lugaresDisponiblesSentados > 0.
	self assert: unMicro lugaresDisponiblesParados > 0
	! !

!Microstest methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/2/2012 18:25'!
test09DadoUnMicroPoderPreguntarSiSePuedeSubirUnaPersona
	| unMicro unaPersonaApurada |
	unMicro := Micro new.
	unaPersonaApurada := PersonaApurada new.
	
	self assert: unMicro lugaresDisponiblesTotales > 0.
	self assert: unMicro lugaresDisponiblesSentados > 0.
	self assert: unMicro lugaresDisponiblesParados > 0.
	self assert: ( unaPersonaApurada subeSiempre)
      ifFalse: [ self error: 'La persona no puede subir al micro.' ].
	
	! !
